#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "ltl.h"

/*Just A Demo for test*/
int main()
{
    int result;
    LtlInfo iot_ltl_info = {0};

    char* userData = "{\"data\":\"this is 用户 data\"}"; // 使用UTF-8编码
    char* iotIdServiceProvider = "pkpkpkpkpkpkpkpk";
    char* timestamp = "1582700146258";

    int userDataLen = strlen(userData);
    int iotIdServiceProviderLen = strlen(iotIdServiceProvider);
    int timestampLen = strlen(timestamp);

    // 1. init
    result = ltlInit();
    if(result != LTL_SUCCESS){
        printf("ltl: init failed!\n");
        return -1;
    }

    iot_ltl_info.userData = userData;
    iot_ltl_info.userDataLen = userDataLen;
    iot_ltl_info.iotIdServiceProvider= iotIdServiceProvider;
    iot_ltl_info.iotIdServiceProviderLen = iotIdServiceProviderLen;
    iot_ltl_info.timestamp = timestamp;
    iot_ltl_info.timestampLen = timestampLen;

    // 2. signature
    result = ltlGetSignature(&iot_ltl_info);
    if(result != LTL_SUCCESS){
        printf("ltl: get iot signature failed!\n");
        return -1;
    }


    printf("================================================================================\n");
    printf("               userData: %s\n", iot_ltl_info.userData);
    printf("            userDataLen: %d\n", iot_ltl_info.userDataLen);
    printf("   iotIdServiceProvider: %s\n", iot_ltl_info.iotIdServiceProvider);
    printf("iotIdServiceProviderLen: %d\n", iot_ltl_info.iotIdServiceProviderLen);
    printf("              timestamp: %s\n", iot_ltl_info.timestamp);
    printf("           timestampLen: %d\n", iot_ltl_info.timestampLen);
    printf("\n");

    printf("            iotAuthType: %s\n", iot_ltl_info.iotAuthType);
    printf("         iotAuthTypeLen: %d\n", iot_ltl_info.iotAuthTypeLen);

    printf("                  iotId: %s\n", iot_ltl_info.iotId);
    printf("               iotIdLen: %d\n", iot_ltl_info.iotIdLen);

    printf("          iotDataDigest: %s\n", iot_ltl_info.iotDataDigest);
    printf("       iotDataDigestLen: %d\n", iot_ltl_info.iotDataDigestLen);

    printf("           iotSignature: %s\n", iot_ltl_info.iotSignature);
    printf("        iotSignatureLen: %d\n", iot_ltl_info.iotSignatureLen);

    printf("ltl: get iot signature success!\n");
    printf("================================================================================\n");

    // 3. release
    result = ltlRelease();
    if(result != LTL_SUCCESS){
        printf("ltl: release failed!\n");
        return -1;
    }
    return 0;
}

