/*
 * Copyright (C) 2017-2019 Alibaba Group Holding Limited
 */

#ifndef __LTL_H__
#define __LTL_H__

#define LTL_SUCCESS (0)
#define LTL_FAIL    (-1)

#define IN 
#define OUT

typedef struct LtlInfo{
    IN char* userData;                      // 用户数据
    IN int userDataLen;                     // 用户数据长度
    IN char* iotIdServiceProvider;          // IoT 可信设备: 服务提供者标识,当前为ID2产品 PK
    IN int iotIdServiceProviderLen;         // IoT 可信设备: 服务提供者标识长度
    IN char* timestamp;                     // IoT 可信设备: 系统时间戳信息, (格式举例: 1582700146253)
    IN int timestampLen;                    // IoT 可信设备: 系统时间戳信息长度
    OUT char iotAuthType[64];               // IoT 可信设备: 认证方式,当前为"ID2"
    OUT int iotAuthTypeLen;                 // IoT 可信设备: 认证方式长度
    OUT char iotId[64];                     // IoT 可信设备: 唯一标识,当前为 ID2(24 字节 ID)
    OUT int iotIdLen;                       // IoT 可信设备: 唯一标识长度
    OUT char iotDataDigest[65];             // IoT 可信设备: 数据摘要信息,SHA-256(64字节大写字符格式)
    OUT int iotDataDigestLen;               // IoT 可信设备: 数据摘要长度
    OUT char iotSignature[256];             // IoT 可信设备: 签名 (当前为ID2签名)
    OUT int iotSignatureLen;                // IoT 可信设备: 签名长度
}LtlInfo;


int ltlInit();


int ltlRelease();


int ltlGetSignature(LtlInfo* ltlInfo);

#endif /*__LTL_H__*/
